#include "cachelib.h"

void cc_sub_begin(pc_subname,pc_hardware)
char *pc_subname;
char *pc_hardware;
{
	char terms[100],*pts=terms;

	init(pc_hardware);
	while(1){
		*pts=*pc_subname;
		if(*pts=='^')*pts='\0';
		if(*pts=='\0')break;
		pts++;
		pc_subname++;
	}
	strcpy(g_subname,terms);
}

void cc_do_begin(pi_init,pi_limit,pi_inc,pc_doname,pi_flag)
int *pi_init,*pi_limit,*pi_inc;
char *pc_doname;
int *pi_flag;
{
	int i_do_entry,i;
	long code_iters;
	char terms[100],*pts=terms;

	g_nest++;
	if(g_nest>=MAX_NEST){
		char c[100];
		sprintf(c,"Error:%s:%s:nest level=%d >= MAX_NEST= %d",
		g_subname,pc_doname,g_nest,MAX_NEST);
		cerror(c);
	}
	while(1){
		*pts=*pc_doname;
		if(*pts=='^')*pts='\0';
		if(*pts=='\0')break;
		pts++;
		pc_doname++;
	}
	i_do_entry = lookup_do(terms);
	g_do_nest_tab[g_nest] = i_do_entry;
	if(g_nest>0 && *pi_flag==0){
		g_do_tab[i_do_entry].iflag = FALSE;
		return;
	}
	code_iters = (*pi_limit - *pi_init + *pi_inc)/(*pi_inc);
	if(code_iters < 0) code_iters=0;
	g_do_tab[i_do_entry].code_iters += code_iters;
/* only do the outermost instrumented loop the first time it is encountered */
#if 1
	if(g_do_tab[i_do_entry].dumped){
		*pi_flag = g_do_tab[i_do_entry].iflag = FALSE;
		return;
	}
#else
	if(g_nest==0 && g_do_tab[i_do_entry].code_iters>0){
		g_do_tab[i_do_entry].iflag = FALSE;
		return;
	}
#endif
	if(g_nest==0){
		init_cache(); /* gw 1/19/98 */
		n_ref_tab=0;
#if 1
		g_first_do=i_do_entry;
#endif
		g_ptracea=g_ptrace=(char*)malloc(g_trace_size);
		if(g_ptracea==NULL){
			char c[100];

			sprintf(c,"Out of memory allocating trace array.");
			cerror(c);
		}
		add_trace_sub(g_subname);
	}
	g_do_tab[i_do_entry].iflag = TRUE;
	*pi_flag=TRUE;
	g_do_tab[i_do_entry].one_time_iters = 0;
	add_trace_do_begin(i_do_entry);
}

void cc_do_iter(piflag)
int *piflag;
{
	int i_do_entry;
/*
	We always do all inner iterations for the first iteration
	of the outer loop. This is where we make cache graphs for
	array references.

	Reasons to set iflag to FALSE:
		1. This is a picked outer loop and it has already 
			been done. (implemented in cc_do_begin)
		
		2. We are not doing a loop which contains this one.

		3. Iteration of this loop greater than MAX_ONE_TIME_ITERS

		4. Total iterations of this loop greater than 
			MAX_TOTAL_ITERS
		
*/
	if(*piflag == FALSE)return;
	i_do_entry = g_do_nest_tab[g_nest];
#if 0
	if(g_nest == 0 && g_do_tab[i_do_entry].sim_iters>0){
		g_bfirst_outer = FALSE;
	}
#endif

	if(g_nest > 0 && !g_do_tab[g_do_nest_tab[g_nest-1]].iflag){
		*piflag = g_do_tab[i_do_entry].iflag = FALSE;
		return;
	}

#if 0
	if(!g_bfirst_outer){
#endif
		if(g_max_single_iters>=0 && 
				g_do_tab[i_do_entry].one_time_iters >= g_max_single_iters){
			*piflag = g_do_tab[i_do_entry].iflag = FALSE;
			return;
		}

		if(g_max_total_iters>=0 && 
				g_do_tab[i_do_entry].sim_iters >= g_max_total_iters){
			*piflag = g_do_tab[i_do_entry].iflag = FALSE;
			return;
		}
#if 0
	}
#endif
	add_trace_do_iter();

	*piflag = g_do_tab[i_do_entry].iflag = TRUE;
	g_do_tab[i_do_entry].one_time_iters++;
	g_do_tab[i_do_entry].sim_iters++;
}

void cc_do_end(piflag)
int *piflag;
{
	g_nest--;
	if(g_nest>0){
		*piflag=g_do_tab[g_do_nest_tab[g_nest]].iflag;
		if(*piflag==0)return;
	}
	add_trace_do_end();
#if 0
	if(g_nest == -1){
		dump_tables();
	}
#else
	if(g_nest == -1 && !g_do_tab[g_do_nest_tab[0]].dumped){
		g_do_tab[g_do_nest_tab[0]].dumped=1;
		dump_tables();
	}
#endif
}

void cc_arrayref(pi_lineno,pi_n,
	pc_a1,pc_string1,pi_esize1,
	pc_a2,pc_string2,pi_esize2,
	pc_a3,pc_string3,pi_esize3,
	pc_a4,pc_string4,pi_esize4,
	pc_a5,pc_string5,pi_esize5,
	pc_a6,pc_string6,pi_esize6,
	pc_a7,pc_string7,pi_esize7,
	pc_a8,pc_string8,pi_esize8,
	pc_a9,pc_string9,pi_esize9,
	pc_a10,pc_string10,pi_esize10)
int *pi_lineno,*pi_n;
char *pc_a1,*pc_string1;
int *pi_esize1;
char *pc_a2,*pc_string2;
int *pi_esize2;
char *pc_a3,*pc_string3;
int *pi_esize3;
char *pc_a4,*pc_string4;
int *pi_esize4;
char *pc_a5,*pc_string5;
int *pi_esize5;
char *pc_a6,*pc_string6;
int *pi_esize6;
char *pc_a7,*pc_string7;
int *pi_esize7;
char *pc_a8,*pc_string8;
int *pi_esize8;
char *pc_a9,*pc_string9;
int *pi_esize9;
char *pc_a10,*pc_string10;
int *pi_esize10;
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	switch (*pi_n) { /* as Shaul says, "no brakes, going downhill." */
	case 10:
		array_ref(pc_a10,pc_string10,*pi_esize10,*pi_lineno);
	case 9:
		array_ref(pc_a9,pc_string9,*pi_esize9,*pi_lineno);
	case 8:
		array_ref(pc_a8,pc_string8,*pi_esize8,*pi_lineno);
	case 7:
		array_ref(pc_a7,pc_string7,*pi_esize7,*pi_lineno);
	case 6:
		array_ref(pc_a6,pc_string6,*pi_esize6,*pi_lineno);
	case 5:
		array_ref(pc_a5,pc_string5,*pi_esize5,*pi_lineno);
	case 4:
		array_ref(pc_a4,pc_string4,*pi_esize4,*pi_lineno);
	case 3:
		array_ref(pc_a3,pc_string3,*pi_esize3,*pi_lineno);
	case 2:
		array_ref(pc_a2,pc_string2,*pi_esize2,*pi_lineno);
	case 1:
		array_ref(pc_a1,pc_string1,*pi_esize1,*pi_lineno);
	}
}

static int enter_ref_tab(pc_aname,lineno)
char *pc_aname;
int lineno;
{
	int i,j;
	ARRAY_REF *par;

	for(i=0;i<n_ref_tab;i++){
		if(strcmp(pc_aname,g_ref_tab[i].aname))continue;
		if(strcmp(g_subname,g_ref_tab[i].subname))continue;
		if(lineno != g_ref_tab[i].lineno)continue;
		break;
	}
	if(i != n_ref_tab)return i;
	n_ref_tab++;
	if(g_ref_tab==NULL){
		g_ref_tab=(ARRAY_REF*)malloc(sizeof(ARRAY_REF));
	}else{
		g_ref_tab=(ARRAY_REF*)realloc(
								g_ref_tab,
								n_ref_tab*sizeof(ARRAY_REF));
	}
	if(g_ref_tab==NULL){
		char c[100];

		sprintf(c,"Out of memory allocating reference table:%d",
			n_ref_tab);
		cerror(c);
	}
	par = &g_ref_tab[i];
	par->subname=malloc(strlen(g_subname)+1);
	if(par->subname==NULL){
		cerror("Out of memory allocating reference table - subname.");
	}
	strcpy(par->subname,g_subname);
	par->aname=malloc(strlen(pc_aname)+1);
	if(par->aname==NULL){
		cerror("Out of memory allocating reference table - array name.");
	}
	strcpy(par->aname,pc_aname);
	par->do_index=g_do_nest_tab[g_nest];
	par->lineno = lineno;
	par->sim_refs = 0;
	par->do_index = g_do_nest_tab[g_nest];
	par->sim_misses=
			(long*)malloc(g_cache_levels*sizeof(*par->sim_misses));
	if(par->sim_misses==NULL){
		cerror("Out of memory allocating reference table - sim misses.");
	}
	for(j=0;j<g_cache_levels;j++){
		par->sim_misses[j] = 0;
	}
#if 0
	par->n_addresses=0;
	par->addresses=NULL;
#endif
	par->n_inter=(int*)malloc(g_cache_levels*sizeof(*par->n_inter));
	if(par->n_inter==NULL){
		cerror("Out of memory allocating interference count.");
	}
	par->inter_entry=
		(INTER_ENTRY**)malloc(g_cache_levels*sizeof(*par->inter_entry));
	if(par->inter_entry==NULL){
		cerror("Out of memory allocating interference entry.");
	}
	for(j=0;j<g_cache_levels;j++){
		par->n_inter[j]=0;
		par->inter_entry[j]=NULL;
	}
	return i;
}

static void array_ref(pc_a,pc_aname,esize,lineno)
char *pc_a; /* array address */
char *pc_aname;
int esize;
int lineno;
{
	int itab;
	int i,j;
	long ia,ic,icm;
	ARRAY_REF *par;
	MACHINE_DESC *pmd = g_machine_desc;
	CACHE_DESC *pcd;
	REF_LINK *prl;
	static int it[10]={0,0,0,0,0,0,0,0,0,0}; /* max 10 cache levels */
	char terms[100],*pts=terms;

	while(1){
		*pts=*pc_aname;
		if(*pts=='^')*pts='\0';
		if(*pts=='\0')break;
		pts++;
		pc_aname++;
	}
	itab = enter_ref_tab(terms,lineno);
	add_trace_array_ref(itab,pc_a);
	par = &g_ref_tab[itab];
	par->sim_refs++;

/* now actually do the cache miss analysis */
	ia=(long)pc_a;
	for(i=0;i<g_cache_levels;i++){
		pcd=&pmd->cache_desc[i];
		ic=ia/pcd->linesize;
		icm=ic-(ic/pcd->tabsize)*pcd->tabsize;
		for(j=0;j<pcd->ntabs;j++){
			if(g_cache_address[i][j][icm]==ic)break;
		}
		if(j<pcd->ntabs)break;
/* we have a cache miss */
		g_ref_tab[itab].sim_misses[i]++;
	/* use "rotating" table location */
		g_cache_address[i][it[i]][icm]=ic;
		if(++it[i]==pcd->ntabs)it[i]=0;
/* do the interference analysis */
		prl=g_cache_history[i][icm];
		for( ;prl;prl=prl->next){
			if(prl->addr==ic)break;
		}
		if(prl==NULL){
			enter_interference(par,i,-1);
		}else{
			REF_LINK *prev_prl;
			prl=g_cache_history[i][icm];
			while(prl->addr!=ic){
				enter_interference(par,i,prl->refno);
				prev_prl=prl;
				prl=prl->next;
			}
	/* remove the old ref */
			prev_prl->next=prl->next;
		}
/* enter the new reference */
		prl=(REF_LINK*)malloc(sizeof(REF_LINK));
		if(prl==NULL){
			cerror("Out of memory allocating reference link.");
		}
		prl->refno=itab;
		prl->addr=ic;
		prl->next=g_cache_history[i][icm];
		g_cache_history[i][icm]=prl;
	}

#if 0
	if(!g_do_addresses)return;
	if(g_n_sort_addresses && par->sim_refs%g_n_sort_addresses==0){
		elim_duplicate_addresses(par);
	}

	if(!par->addresses){
		par->addresses = (char**)malloc(sizeof(char*)*(par->n_addresses+1));
	}else{
		par->addresses = (char**)realloc(par->addresses,
							sizeof(char*)*(par->n_addresses+1));
	}
	if(par->addresses==NULL){
		char c[100];

		sprintf(c,"Out of memory allocating reference table - addresses:%d",
			par->n_addresses+1);
		cerror(c);
	}
	par->addresses[par->n_addresses] = pc_a;
	par->n_addresses++;
#endif
}

static void enter_interference(par,cache_level,refno)
ARRAY_REF *par;
int cache_level;
int refno;
{
	int i;	

	for(i=0;i<par->n_inter[cache_level];i++){
		if(par->inter_entry[cache_level][i].ref==refno){
			par->inter_entry[cache_level][i].count++;
			return;
		}
	}
	if(par->n_inter[cache_level]==0){
		par->inter_entry[cache_level]=
				(INTER_ENTRY*)malloc(sizeof(**par->inter_entry));
	}else{
		par->inter_entry[cache_level]=(INTER_ENTRY*)realloc(
				par->inter_entry[cache_level],
				(par->n_inter[cache_level]+1)*sizeof(**par->inter_entry));
	}
	if(par->inter_entry[cache_level]==NULL){
		char c[100];

		sprintf(c,"Out of memory allocating interference table:%d",
			par->n_inter[cache_level]);
		cerror(c);
	}
	par->inter_entry[cache_level][par->n_inter[cache_level]].ref=refno;
	par->inter_entry[cache_level][par->n_inter[cache_level]].count=1;
	par->n_inter[cache_level]++;
}

#if 0
static void elim_duplicate_addresses(par)
ARRAY_REF *par;
{
	long na,j;
	char *last;

	qsort(par->addresses,par->n_addresses,sizeof(char*),
		addrcompare);
	na=0;
	for(j=0;j<par->n_addresses;j++){
		if(j==0 || par->addresses[j]!=last){
			par->addresses[na] = par->addresses[j];
			na++;
		}
		last = par->addresses[j];
	}
#if 0
	printf("elim_duplicate_addresses:old n=%ld new n=%ld\n",
		par->n_addresses,na);
#endif
	par->n_addresses = na;
}
#endif

static void init(pc_hardware)
char *pc_hardware;
{
	if(g_binit)return;
	g_binit = 1;
	if(sizeof(long) < sizeof(char*)){
		char c[100];

		sprintf(c,"sizeof(long)=%d less than sizeof(char*)=%d",
			sizeof(long),sizeof(char*));
		cerror(c);
	}
	init_env(pc_hardware);
}

static void init_cache()
{
	int i,j,k;
	MACHINE_DESC *pmd = g_machine_desc;
	CACHE_DESC *pcd;

	g_cache_address=(long***)malloc(g_cache_levels*sizeof(long**));
	g_cache_history=(REF_LINK***)malloc(g_cache_levels*sizeof(REF_LINK**));
	if(g_cache_address==NULL || g_cache_history==NULL){
		cerror("Out of memory allocating cache table.");
	}
	for(i=0;i<g_cache_levels;i++){
		pcd=&pmd->cache_desc[i];
		g_cache_address[i]=(long**)malloc(pcd->ntabs*sizeof(long*));
		g_cache_history[i]=
				(REF_LINK**)malloc(pcd->tabsize*sizeof(REF_LINK*));
		if(g_cache_address[i]==NULL || g_cache_history[i]==NULL){
			cerror("Out of memory allocating cache table[].");
		}
		for(j=0;j<pcd->ntabs;j++){
			g_cache_address[i][j]=(long*)malloc(pcd->tabsize*sizeof(long));
			if(g_cache_address[i][j]==NULL){
				char c[100];

				sprintf(c,"Out of memory allocating cache table[][]:%d",
					pcd->tabsize);
				cerror(c);
			}
			for(k=0;k<pcd->tabsize;k++){
				g_cache_address[i][j][k]=0;
			}
		}
		for(k=0;k<pcd->tabsize;k++){
			g_cache_history[i][k]=NULL;
		}
	}
}

static int lookup_do(pc_doname)
char *pc_doname;
{
	int i;
	DO_ENTRY *pd;

	for(i=0;i<n_do_tab;i++){
		if(strcmp(pc_doname,g_do_tab[i].doname))continue;
		if(strcmp(g_subname,g_do_tab[i].subname))continue;
		break;
	}
	if(i<n_do_tab)return i;
/* new entry */
#if 0
	if(g_nest == 0)g_bfirst_outer = TRUE;
#endif
	n_do_tab++;
	if(g_do_tab==NULL){
		g_do_tab=(DO_ENTRY*)malloc(sizeof(DO_ENTRY));
	}else{
		g_do_tab=(DO_ENTRY*)realloc(
								g_do_tab,
								n_do_tab*sizeof(DO_ENTRY));
	}
	if(g_do_tab==NULL){
			char c[100];

			sprintf(c,"Out of memory allocating DO table:%d",
				n_do_tab);
			cerror(c);
	}
	pd = &g_do_tab[i];
	pd->doname=malloc(strlen(pc_doname)+1);
	if(pd->doname==NULL){
			cerror("Out of memory allocating DO table - DO name.");
	}
	strcpy(pd->doname,pc_doname);
	pd->subname=malloc(strlen(g_subname)+1);
	if(pd->subname==NULL){
			cerror("Out of memory allocating DO table - sub name.");
	}
	strcpy(pd->subname,g_subname);
	pd->code_iters = 0;
	pd->sim_iters = 0;
	pd->iflag=0;
#if 1
	pd->dumped=0;
#endif
	if(g_nest==0){
		pd->parent = -1;
	}else{
		pd->parent = g_do_nest_tab[g_nest-1];
	}
	return i;
}

static void dump_tables()
{
	int i,na,k;
	long j;
	DO_ENTRY *pd;
	ARRAY_REF *par;
	char *last;
	static char ifirst=1;
	CACHE_DESC *pcd;

	if(ifirst){
		freport = fopen(CACHE_REPORT_NAME,"w");
		fprintf(freport,"%s\n",CACHE_REPORT_VERSION);
		if(g_do_addresses==0)fprintf(freport,"NOT ");
		fprintf(freport,"Doing memory addresses\n");
		fprintf(freport,"MACHINE DESCRIPTION:\n");
		fprintf(freport,"    NAME:%s\n",g_machine_desc->name);
		fprintf(freport,"    pointer size:%d\n",sizeof(char*));
		for(i=0;i<g_machine_desc->nlevels;i++){
			pcd= &g_machine_desc->cache_desc[i];
			if(pcd->tlb){
				fprintf(freport,"  TLB:\n");
			}else{
				fprintf(freport,"  CACHE LEVEL %d:\n",i+1);
			}
			fprintf(freport,"    number of tables %d\n",pcd->ntabs);
			fprintf(freport,"    line size (bytes): %d\n",pcd->linesize);
			fprintf(freport,"    one cache table size (lines): %d\n",pcd->tabsize);
			fprintf(freport,"    one cache table size (bytes): %d\n",
							pcd->tabsize*pcd->linesize);
		}
		fprintf(freport,"MAX_SINGLE_ITERS=%ld\n",g_max_single_iters);
		fprintf(freport,"MAX_TOTAL_ITERS=%ld\n",g_max_total_iters);
		ifirst=0;
	}else{
		freport=NULL;
		freport = fopen(CACHE_REPORT_NAME,"a+");
	}
	fprintf(freport,">>> LOOPS\n");
	fprintf(freport,"\n");
#if 1
	for(i=g_first_do;i<n_do_tab;i++){
#else
	for(i=0;i<n_do_tab;i++){
	}
#endif
		pd = &g_do_tab[i];
		fprintf(freport,"%3d %s : %s # parent=%3d\n",
					i-g_first_do,pd->subname,pd->doname,pd->parent);
		fprintf(freport,"    actual iters    = %ld\n",pd->code_iters);
		fprintf(freport,"    simulated iters = %ld\n",pd->sim_iters);
	}
	fprintf(freport,"\n");
	fprintf(freport,">>> ARRAY REFERENCES\n");
	fprintf(freport,"\n");
	for(i=0;i<n_ref_tab;i++){
		long projected_refs,projected_misses;
		float x;

		par = &g_ref_tab[i];
		fprintf(freport,
			"reference #%d %s : %s : do #%3d : source line number %d\n",
			i+1,par->subname,par->aname,par->do_index-g_first_do,par->lineno);
		fprintf(freport,"    simulated references  = %ld\n",
				par->sim_refs);
		pd = &g_do_tab[par->do_index];
		x = par->sim_refs;
		x = x * pd->code_iters;
		x = x/pd->sim_iters;
		projected_refs = x;
		fprintf(freport,"    projected references  = %ld\n",
				projected_refs);
		
		for(j=0;j<g_machine_desc->nlevels;j++){
			fprintf(freport,
				"    simulated cache misses for level %ld  = %ld %ld%%\n",
					j+1,par->sim_misses[j],
					(par->sim_misses[j]*100)/par->sim_refs);
			x = par->sim_misses[j] * pd->code_iters;
			x = x/pd->sim_iters;
			projected_misses = x;
			fprintf(freport,
				"    projected cache misses for level %ld  = %ld %ld%%\n",
					j+1,projected_misses,
					(projected_misses*100)/projected_refs);
			fprintf(freport,
				"    number of interfering references = %d\n",
					par->n_inter[j]);
			qsort(par->inter_entry[j],par->n_inter[j],
					sizeof(*par->inter_entry[j]),
					inter_compare);
			for(k=0;k<par->n_inter[j];k++){
				fprintf(freport,"      %4d ref #%ld count=%ld\n",
					k+1,
					par->inter_entry[j][k].ref+1,
					par->inter_entry[j][k].count);
			}
		}
#if 0
		if(!g_do_addresses){
			free(par);
			continue;
		}

		fprintf(freport,"    references:\n");
#if 0
		printf("dump_tables:%s:%s n_addresses=%ld\n",
			par->subname,par->aname,par->n_addresses);
#endif
		qsort(par->addresses,par->n_addresses,sizeof(char*),
			addrcompare);
		na=0;
		for(j=0;j<par->n_addresses;j++){
			if(j==0 || par->addresses[j]!=last){
				fprintf(freport," 0x%8.8x",par->addresses[j]);
				na++;
				if(na==4){
					na=0;
					fprintf(freport,"\n");
				}
			}
			last = par->addresses[j];
		}
		if(na!=0)fprintf(freport,"\n");
		fprintf(freport,"\n");
		free(par);
#endif
	}
	free(g_ref_tab);
	g_ref_tab=NULL;
#if 0
	free(g_do_tab);
	g_do_tab=NULL;
	n_do_tab=0;
#endif
/* in case trace array overflowed, end all loops */
	for(i=0;i<30;i++)*g_ptrace++='E';
	*g_ptrace++='\n';
	*g_ptrace++='\0';
	fputs(g_ptracea,freport);
	free(g_ptracea);
	fclose(freport);
}

#if 0
static int addrcompare(pa,pb)
char **pa,**pb;
{
	if(*pa == *pb)return 0;
	if(*pa > *pb)return 1;
	return -1;
}
#endif

static int inter_compare(pa,pb)
INTER_ENTRY *pa,*pb;
{
	if(pa->ref == -1)return -1;
	if(pb->ref == -1)return  1;
	if(pa->count == pb->count)return 0;
	if(pa->count < pb->count)return 1;
	return -1;
}

static void init_env(pc_hardware)
char *pc_hardware;
{
	char *s,cs[100];
	int i,j;
	CACHE_DESC *pcd;
	MACHINE_DESC *pmd;
	char c[50];
/*
HP 1 level
	tables=1, cachelinesize=32, cachesize=32768 cachelines, TLB=0
*/
	static CACHE_DESC HP[] =
	{
		{1,32,32768,0}
	};
/*
RS600 2 levels
	tables=4, cachelinesize=256, cachesize=256 cachelines, TLB=0
	tables=1, cachelinesize=4096, TLBsize=512 pages,TLB=1
*/
	static CACHE_DESC RS6000[] =
	{
		{4,256,256,0},
		{1,4096,512,1}
	};
/*
SGI_r10000 2 levels
	tables=2, cachelinesize=32, cachesize=4096 cachelines, TLB=0
	tables=2, cachelinesize=128, cachesize=4096 cachelines, TLB=0
*/
	static CACHE_DESC SGI_r10000[] =
	{
		{2,32,4096,0},
		{2,128,4096,0}
	};
/*
Intel_Pentium 2 levels
	tables=2, cachelinesize=32, cachesize=128 cachelines, TLB=0
	tables=4, cachelinesize=32, cachesize=4096 cachelines, TLB=0
*/
	static CACHE_DESC Intel_Pentium[] =
	{
		{2,32,128,0},
		{4,32,4096,0}
	};
/*
Meiko_CS2 2 levels
	tables=1, cachelinesize=32, cachesize=512 cachelines, TLB=0
	tables-1, cachelinesize=32, cachesize=8192 cachelines, TLB=0
*/
	static CACHE_DESC Meiko_CS2[] =
	{
		{1,32,512,0},
		{1,32,8192,0}
	};
/* 
dec_ALHPA 3 levels
	tables=1, cachelinesize=32, cachesize=256 cachelines, TLB=0
	tables=3, cachelinesize=64, cachesize=512 cachelines, TLB=0
	tables=1, cachelinesize=64, cachesize=131072 cachelines, TLB=0
*/
	static CACHE_DESC dec_ALPHA[] =
	{
		{1,32,256,0},
		{3,64,512,0},
		{1,64,131072,0}
	};
/*
sgi_ORIGIN 2 levels
	tables=2, cachelinesize=64, cachesize=256 cachelines, TLB=0
	tables=2, cachelinesize=256,cachesize=8192 cachelines, TLB=0
*/
	static CACHE_DESC sgi_ORIGIN[] =
	{
		{2,64,256,0},
		{2,256,8192,0}
	};

	static MACHINE_DESC md[] = 
	{
		{"hp-9000",1,HP},
		{"ibm-RS6000",2,RS6000},
		{"SGI-r10000",2,SGI_r10000},
		{"pc-INTEL",2,Intel_Pentium},
		{"Meiko-CS2",2,Meiko_CS2},
		{"dec-ALPHA",3,dec_ALPHA},
		{"sgi-ORIGIN",2,sgi_ORIGIN},

		{0,0,0}
	};

	g_machine_desc=pmd=(MACHINE_DESC*)malloc(sizeof(MACHINE_DESC));
	if(g_machine_desc==NULL){
			cerror("Out of memory allocating Machine table.");
	}
	pmd->nlevels=0;
	pmd->cache_desc=(CACHE_DESC*)malloc(sizeof(CACHE_DESC));
	if(pmd->cache_desc==NULL){
			cerror("Out of memory allocating Machine table - cache.");
	}
	pmd->name=malloc(strlen("NONAME")+1);
	if(pmd->name==NULL){
			cerror("Out of memory allocating Machine table - name.");
	}
	strcpy(pmd->name,"NONAME");

	s = getenv("CACHE_NO_ADDRESSES");
	if(s)g_do_addresses=0;
#if 0
	s = getenv("CACHE_N_SORT_ADDRESSES");
	if(s && *s)g_n_sort_addresses=atoi(s);
#endif
	strcpy(cs,pc_hardware);
	s = getenv("CACHE_MACHINE");
	if(!(s && *s))s=cs;
	if(s && *s){
		for(i=0;md[i].name;i++) {
			if(strcasecmp(s,md[i].name))continue;
			pmd->name=realloc(pmd->name,strlen(md[i].name+1));
			if(pmd->name==NULL){
				cerror("Out of memory allocating machine name.");
			}
			strcpy(pmd->name,md[i].name);
			pmd->nlevels=g_cache_levels=md[i].nlevels;
			pmd->cache_desc=(CACHE_DESC*)realloc(pmd->cache_desc,
							md[i].nlevels*sizeof(CACHE_DESC));
			if(pmd->cache_desc==NULL){
				cerror("Out of memory allocating cache desc.");
			}
			for(j=0;j<pmd->nlevels;j++){
				pmd->cache_desc[j].ntabs=md[i].cache_desc[j].ntabs;
				pmd->cache_desc[j].linesize=md[i].cache_desc[j].linesize;
				pmd->cache_desc[j].tabsize=md[i].cache_desc[j].tabsize;
				pmd->cache_desc[j].tlb=md[i].cache_desc[j].tlb;
			}
		}
	}

	s = getenv("CACHE_N");
	if(s && *s){
		i=atoi(s);
		pmd->cache_desc=(CACHE_DESC*)realloc(pmd->cache_desc,
					i*sizeof(CACHE_DESC));
		if(pmd->cache_desc==NULL){
			cerror("Out of memory allocating cache desc.");
		}
		for(j=pmd->nlevels;j<i;j++){
			pmd->cache_desc[j].ntabs=1;
			pmd->cache_desc[j].linesize=0;
			pmd->cache_desc[j].tabsize=0;
			pmd->cache_desc[j].tlb=0;
		}
		pmd->nlevels=g_cache_levels = i;
	}
	for(i=0;i<pmd->nlevels;i++){
		sprintf(c,"CACHE_TLB%d",i+1);
		s=getenv(c);
		if(s){
			pmd->cache_desc[i].tlb=1;
		}
		sprintf(c,"CACHE_NTABS%d",i+1);
		s=getenv(c);
		if(s && *s){
			pmd->cache_desc[i].ntabs=atoi(s);
		}
		sprintf(c,"CACHE_LINESIZE%d",i+1);
		s=getenv(c);
		if(s && *s){
			pmd->cache_desc[i].linesize=atoi(s);
		}
		sprintf(c,"CACHE_TABSIZE%d",i+1);
		s=getenv(c);
		if(s && *s){
			pmd->cache_desc[i].tabsize=atoi(s);
		}
	}
	s = getenv("CACHE_MAX_TOTAL_ITERATIONS");
	if(s && *s)g_max_total_iters=atol(s);
	s = getenv("CACHE_MAX_SINGLE_ITERATIONS");
	if(s && *s)g_max_single_iters=atol(s);
	s = getenv("CACHE_TRACE_SIZE");
	if(s && *s)g_trace_size=atol(s);
	init_check_errors(g_machine_desc,md);
}

static void init_check_errors(md,md_init)
MACHINE_DESC *md,*md_init;
{
	char err=0;
	int i;

	if(g_cache_levels<=0){
		err=1;
		printf("Illegal value for number of cache levels: %d\n",
			g_cache_levels);
	}else{
		for(i=0 ; i<g_cache_levels ; i++){
			if(!ipow2(md->cache_desc[i].tabsize)){
				printf("Illegal value for cache table size %d: %d\n",
					i+1,md->cache_desc[i].tabsize);
					err=1;
			}
			if(!ipow2(md->cache_desc[i].linesize)){
				printf("Illegal value for cache line size %d: %d\n",
					i+1,md->cache_desc[i].linesize);
					err=1;
			}
			if(md->cache_desc[i].ntabs<=0){
				printf("Illegal value for number of cache tables %d: %d\n",
					i+1,md->cache_desc[i].linesize);
					err=1;
			}
		}
	}
	if(err){
		dump_machine_desc();
		print_instructions(md_init);
		exit(3);
	}
}

static void dump_machine_desc()
{
	MACHINE_DESC *pmd;
	CACHE_DESC *pcd;
	int i;

	pmd = g_machine_desc;
	printf("The parameters for memory simulation are:\n");
	printf("  machine name:%s\n",pmd->name);
	printf("  cache levels:%d\n",pmd->nlevels);
	for(i=0;i<pmd->nlevels;i++){
		printf("  level %d:\n",i+1);
		pcd = &pmd->cache_desc[i];
		if(pcd->tlb){
			printf("    TLB\n");
			printf("    page size=%d\n",pcd->linesize);
			printf("    TLB entries=%d\n",pcd->tabsize);
		}else{
			printf("    cache line size=%d\n",pcd->linesize);
			printf("    number of tables=%d\n",pcd->ntabs);
			printf("    each table contains %d cache lines, %d bytes\n",
				pcd->tabsize,pcd->tabsize*pcd->linesize);
		}
	}
	printf("  trace size  :%d\n",g_trace_size);
}

static void print_instructions(md)
MACHINE_DESC *md;
{
	int i;
	CACHE_DESC *cd;
	static char *instructions1[] = {
"The APR cache instrumentation library uses environment variables to set",
"cache characteristics. The environment variable CACHE_MACHINE can be",
"used to set all characteristics. Allowed values for CACHE_MACHINE and",
"their cache characteristics are:",
0
	};

static char *instructions2[] = {
"Individual characteristics can be changed by setting one or more",
"more of the following variables:",
" ",
"         CACHE_N - number of cache levels. integer > 0",
" ",
"For each cache level the cache line size, number of cache tables and",
"table size can be set with environment variables. The last character of ",
"the environment variable is an integer specifying the cache number [1-N].",
"         CACHE_LINESIZE<n> - number of bytes in a cache line for ",
"                             level one cache. Must be a power of 2 .",
" ",
"         CACHE_TABSIZE<n> - number of cache lines in a cache table for",
"                            cache level <n>.",
" ",
"         CACHE_NTABS<n> - number of cache tables for level <n>.",
" ",
"         CACHE_TLB<n> - if set, indicates that cache level<n> is really",
"                        a TLB. The pagesize is set with the variable",
"                        CACHE_LINESIZE<n>. The number of TLB's,",
"                        typically 1, is set with the variable CACHE_NTABS<n>.",
"                        The number of entries in the TLB is set with the",
"                        variable CACHE_TABSIZE<n>.",
" ",
"The APR cache instrumentation requires a signifigant amount of time",
"for every memory reference in the selected loop(s). To reduce",
"execution time a subset of loop iterations can be selected by setting",
"the following environment variables. The limits apply to all loops",
"within the selected loop nest(s).",
" ",
"         CACHE_MAX_TOTAL_ITERATIONS - after this many total iterations,",
"                       memory references within a loop will not be",
"                       simulated.",
" ",
"         CACHE_MAX_SINGLE_ITERATIONS - each time a loop is encountered",
"                       no more than this many iterations will be",
"                       simulated.",
" ",
"Each outermost instrumented loop is simulated the first time it is",
"encountered in the program. Subsequent executions do not have memory",
"simulation.",
" ",
"Memory addresses are saved during the first iteration of a selected",
"loop to allow production of cache pictures. This feature may",
"exhaust dynamic memory. It can disable by setting the environment",
"variable CACHE_NO_ADDRESSES.",
" ",
"The number of addresses, or traces saved can be controlled by setting",
"the environment variable CACHE_TRACE_SIZE. This is the maximum number",
"of bytes that will be generated for each outermost instrumented loop.",
"The default is 2,000,000.",
	0 };
	char **s = instructions1;

	while(*s){
		printf("%s\n",*s);
		s++;
	}

	while(md->name){
		printf("%s\n",md->name);
		printf("  cache levels:%d\n",md->nlevels);
		for(i=0;i<md->nlevels;i++){
			printf("  level %d:\n",i+1);
			cd = &md->cache_desc[i];
			if(cd->tlb){
				printf("    TLB\n");
				printf("    page size=%d\n",cd->linesize);
				printf("    TLB entries=%d\n",cd->tabsize);
			}else{
				printf("    cache line size=%d\n",cd->linesize);
				printf("    number of tables=%d\n",cd->ntabs);
				printf("    each table contains %d cache lines, %d bytes\n",
					cd->tabsize,cd->tabsize*cd->linesize);
			}
		}
		md++;
	}

	s=instructions2;
	while(*s){
		printf("%s\n",*s);
		s++;
	}
}

static int ipow2(i)
int i;
{
	if(i<=0)return 0;
	if(i==1)return 1;
	while(i>1){
		if((i>>1)<<1 != i)return 0;
		i = i>>1;
	}
	return 1;
}

static void cerror(s)
char *s;
{
	printf("////// CACHE INSTRUMENTATION ERROR ///////\n");
	printf("%s\n",s);
	exit(101);
}

static void add_trace_sub(psubname)
char *psubname;
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	*g_ptrace++ = 'S';
	strcpy(g_ptrace,psubname);
	g_ptrace+=strlen(psubname);
	*g_ptrace++ = '\n';
}

static void add_trace_do_begin(i)
int i;
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	*g_ptrace++ = 'D';
	sprintf(g_ptrace,"%3d",i-g_first_do);
	g_ptrace += 3;
}

static void add_trace_do_iter()
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	*g_ptrace++ = 'I';
}

static void add_trace_do_end()
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	*g_ptrace++ = 'E';
}

static void add_trace_array_ref(i,pa)
int i;
char *pa;
{
	if(g_ptrace-g_ptracea+100>g_trace_size)return;
	*g_ptrace++ = 'A';
	if(sizeof(pa)==4){
		sprintf(g_ptrace,"%3.3d%8.8x",i,pa);
		g_ptrace += 11;
	}else if(sizeof(pa)==8){
		sprintf(g_ptrace,"%3.3d%16.16x",i,pa);
		g_ptrace += 19;
	}else{
		cerror("Illegal pointer size.");
	}
	*g_ptrace++ = '\n';
}


